#include "game.h"
#include "cursor.h"
#include "display.h"
#include "input.h"
#include "arguments.h"

// The way things are designed to work:
//  1. out initializes a new display (this is a virtual one)
//  2. out initializes output based on given args
//       This is when curse is initialized (curse.init())
//  3. game_proc binds output to out and curses (if needed)

// Notes:
//  1. game sends all output to display and gets all input from input
//  2. display either renders to file (console) or curse
//  3.

int main(int argc, char **argv) {
        logger log;
        cursor curse;
        input in(curse);
        feature enabled_features = proc_args(argc, argv, curse, in, log);
        display out(curse, enabled_features);

        // binds display to the game
        game game_proc(in, out, argc, argv);

        while (game_proc.run() != game_status::terminated)
                out.render();

        return 0;
}
